coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[PATCH] sleep,timeout: support overflowing floating point values


From: Pádraig Brady
Subject: [PATCH] sleep,timeout: support overflowing floating point values
Date: Wed, 20 Apr 2016 18:31:39 +0100

* src/sleep.c (main): Allow ERANGE since we allow "inf" values.
* src/timeout.c (parse_duration): Likewise.
* tests/misc/sleep.sh: New file. Tests for sleep(1).
* tests/misc/timeout-parameters.sh: Add case for newly allowed
$LDBL_MAX.  Also use returns_ throughout the file.  Also avoid
small timeout values which might give false failures under load.
---
 src/sleep.c                      |  2 +-
 src/timeout.c                    |  2 +-
 tests/local.mk                   |  1 +
 tests/misc/sleep.sh              | 38 ++++++++++++++++++++++++++++++++++++++
 tests/misc/timeout-parameters.sh | 26 ++++++++++++--------------
 5 files changed, 53 insertions(+), 16 deletions(-)
 create mode 100755 tests/misc/sleep.sh

diff --git a/src/sleep.c b/src/sleep.c
index a865c76..acee3bb 100644
--- a/src/sleep.c
+++ b/src/sleep.c
@@ -124,7 +124,7 @@ main (int argc, char **argv)
     {
       double s;
       const char *p;
-      if (! xstrtod (argv[i], &p, &s, c_strtod)
+      if (! (xstrtod (argv[i], &p, &s, c_strtod) || errno == ERANGE)
           /* Nonnegative interval.  */
           || ! (0 <= s)
           /* No extra chars after the number and an optional s,m,h,d char.  */
diff --git a/src/timeout.c b/src/timeout.c
index 9c31df5..462ef6b 100644
--- a/src/timeout.c
+++ b/src/timeout.c
@@ -314,7 +314,7 @@ parse_duration (const char* str)
   double duration;
   const char *ep;
 
-  if (!xstrtod (str, &ep, &duration, c_strtod)
+  if (! (xstrtod (str, &ep, &duration, c_strtod) || errno == ERANGE)
       /* Nonnegative interval.  */
       || ! (0 <= duration)
       /* No extra chars after the number and an optional s,m,h,d char.  */
diff --git a/tests/local.mk b/tests/local.mk
index a83c3d0..424f460 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -333,6 +333,7 @@ all_tests =                                 \
   tests/misc/shred-size.sh                     \
   tests/misc/shuf.sh                           \
   tests/misc/shuf-reservoir.sh                 \
+  tests/misc/sleep.sh                          \
   tests/misc/sort.pl                           \
   tests/misc/sort-benchmark-random.sh          \
   tests/misc/sort-compress.sh                  \
diff --git a/tests/misc/sleep.sh b/tests/misc/sleep.sh
new file mode 100755
index 0000000..38d6913
--- /dev/null
+++ b/tests/misc/sleep.sh
@@ -0,0 +1,38 @@
+#!/bin/sh
+# Validate sleep parameters
+
+# Copyright (C) 2016 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ sleep
+getlimits_
+
+# invalid timeouts
+returns_ 1 timeout 10 sleep invalid || fail=1
+returns_ 1 timeout 10 sleep -- -1 || fail=1
+returns_ 1 timeout 10 sleep 42D || fail=1
+returns_ 1 timeout 10 sleep 42d 42D || fail=1
+
+# subsecond actual sleep
+timeout 10 sleep 0.001 || fail=1
+
+# Small timeouts for larger sleeps racy,
+# but false positives should be avoided on most systems
+returns_ 124 timeout 0.1 sleep 1d 2h 3s 4m || fail=1
+returns_ 124 timeout 0.1 sleep inf || fail=1
+returns_ 124 timeout 0.1 sleep $LDBL_MAX || fail=1
+
+Exit $fail
diff --git a/tests/misc/timeout-parameters.sh b/tests/misc/timeout-parameters.sh
index 14c9b66..28e7c15 100755
--- a/tests/misc/timeout-parameters.sh
+++ b/tests/misc/timeout-parameters.sh
@@ -24,16 +24,13 @@ getlimits_
 # internal errors are 125, distinct from execution failure
 
 # invalid timeout
-timeout invalid sleep 0
-test $? = 125 || fail=1
+returns_ 125 timeout invalid sleep 0 || fail=1
 
 # invalid kill delay
-timeout --kill-after=invalid 1 sleep 0
-test $? = 125 || fail=1
+returns_ 125 timeout --kill-after=invalid 1 sleep 0 || fail=1
 
 # invalid timeout suffix
-timeout 42D sleep 0
-test $? = 125 || fail=1
+returns_ 125 timeout 42D sleep 0 || fail=1
 
 # It was seen on 32 bit Linux/HPPA that a kernel time_t overflowed,
 # thus causing the timer to fire immediately.
@@ -50,24 +47,25 @@ if test $? != 124; then
 
   # floating point notation
   timeout 2.34e+5d sleep 0 || fail=1
+
+  # floating point overflow
+  timeout $LDBL_MAX sleep 0 || fail=1
+  returns_ 125 timeout -- -$LDBL_MAX sleep 0 || fail=1
 fi
 
 # floating point notation
-timeout 2.34 sleep 0 || fail=1
+timeout 10.34 sleep 0 || fail=1
 
 # nanoseconds potentially supported
-timeout .999999999 sleep 0 || fail=1
+timeout 9.999999999 sleep 0 || fail=1
 
 # invalid signal spec
-timeout --signal=invalid 1 sleep 0
-test $? = 125 || fail=1
+returns_ 125 timeout --signal=invalid 1 sleep 0 || fail=1
 
 # invalid command
-timeout 10 .
-test $? = 126 || fail=1
+returns_ 126 timeout 10 . || fail=1
 
 # no such command
-timeout 10 no_such
-test $? = 127 || fail=1
+returns_ 127 timeout 10 no_such || fail=1
 
 Exit $fail
-- 
2.5.5




reply via email to

[Prev in Thread] Current Thread [Next in Thread]